import "dart:math" as m;

/**
 * Property encapsulates a Value 
 * 
 */
class Property {
  //Constructors
  Property(double this._value);

  factory Property.createFromCrossover(Property first, Property second) {
    var value = (first.value + second.value) / 2.0;
    return new Property(value);
  }

  //Values
  // The value encapsulated in a Property objec
  double _value;
  double get value => this._value;
  set value(double v) => this._value = v;

  m.Random r = new m.Random();

  // Methods
  ///
  double mutate_problem(double value) {
    double add = ((r.nextDouble() - 0.5) * 2.0);

    return value + add;
  }

  void mutate() {
    double r = mutate_problem(this.value);
    this.value = r;
  }
}
