import "../lib/evo.dart";
import "../lib/src/agent.dart";
import "../lib/src/property.dart";
import "../lib/src/propertyWithDeviation.dart";

import "dart:mirrors" as mirrors;

void main1() {
  double v = 1.0;
  double s = 1.0;

  Property p = new Property(v);
  PropertyWithDeviation ps = new PropertyWithDeviation(v, s);

  // Agent a = Agent(<PropertyWithDeviation>[PropertyWithDeviation(1.0, 2.0)]);

  var size = 3;
  Agent a = Agent.createNormalWithDeviation(size);
  Agent clone1 = Agent.createAsClone(a);
  Agent clone2 = Agent.createAsClone(a);

  clone1.mutate();
  print(clone1);
  print(clone2);
}

void f(int i, int j) {}

void main() {
  print("Library Differential Evolutions");

  mirrors.ClosureMirror ft = mirrors.reflect(f) as mirrors.ClosureMirror;

  print("Funktion" + ft.function.qualifiedName.toString());
  List<mirrors.ParameterMirror> pars = ft.function.parameters;
  print("Anzahl der Argumente: " + pars.length.toString());
  for (var p in pars) {
    print(" Name " +
        p.qualifiedName.toString() +
        " Typ: " +
        p.type.toString() +
        "");
  }
}
