import 'dart:math' as math;
import 'dimension2.dart';

///
class Agent {
  /// Consruct Agent randomly from Dimensions dimensionIn
  Agent(this.dimensionIn) {
    dataValue = dimensionIn.map((var d) {
      return random.nextDouble() * (d.upper - d.lower) + d.lower;
    }).toList();
  }
  math.Random random = new math.Random();

  /// Liste von nums für jede Dimension ein Wert ,
  final List<Dimension> dimensionIn;

  /// Liste von nums für jede Dimension ein Wert ,
  List<num> dataValue;

  Agent clone() {
    return Agent(this.dimensionIn)..dataValue = List.of(this.dataValue);
  }

  @override
  String toString() => " " + dataValue.join(", ") + " ;";
}
