import "package:test/test.dart";

import "package:evo/evo.dart";
//import "package:evo/agent.dart";
//import "../lib/src/property.dart";
//import "package:evo/propertyWithDeviation.dart";

void main() {
  group("Property", () {
    double v = 1.0;
    double s = 1.0;

    Property p = new Property(v);
    PropertyWithDeviation ps = new PropertyWithDeviation(v, s);

    Agent a = Agent(<PropertyWithDeviation>[PropertyWithDeviation(1, 2)]);

    setUp(() async {});

    test("Property.value: get, set ", () {
      expect(p.value, equals(v));
    });

    test("Property.value: Type == double", () {
      expect(p.value.runtimeType, equals(double));
    });

    test("Agents", () {
      Agent clone1 = Agent.createAsClone(a);
      Agent clone2 = Agent.createAsClone(a);

      clone1.mutate();
      print(clone1);
      print(clone2);
    });
  });

  tearDown(() async {});
}
